module Oneds
  module Mrproper
    module One
      module Managers
        class DatastoreManager < Oneds::Mrproper::One::Managers::Manager
          def initialize(client)
            super(client)
            @pool = OpenNebula::DatastorePool.new client
          end

          def datastore_paths
            reload!

            pool.map { |datastore| datastore['BASE_PATH'] }
          end

          def image_datastores
            reload!

            pool.find_all { |datastore| datastore.type_str == 'IMAGE' }
          end

          def system_datastores
            reload!

            pool.find_all { |datastore| datastore.type_str == 'SYSTEM' }
          end
        end
      end
    end
  end
end
