module Oneds
  module Mrproper
    module One
      module Managers
        class ImageManager < Oneds::Mrproper::One::Managers::Manager
          def initialize(client)
            super(client)
            @pool = OpenNebula::ImagePool.new client
          end

          def image_file(image_id)
            image = OpenNebula::Image.new(OpenNebula::Image.build_xml(image_id.to_i), client)
            Oneds::Mrproper::One::Helper.handle_opennebula_error { image.info }

            image['SOURCE']
          rescue Oneds::Mrproper::Errors::One::ResourceNotFoundError => ex
            logger.error "Image not found: #{ex.message}"
          end
        end
      end
    end
  end
end
