module Oneds
  module Mrproper
    module One
      module Managers
        class VirtualMachineManager < Oneds::Mrproper::One::Managers::Manager
          VM_DONE_STATE = 6

          def initialize(client)
            super(client)
          end

          def virtual_machine(vm_id)
            vm = OpenNebula::VirtualMachine.new(OpenNebula::VirtualMachine.build_xml(vm_id), client)
            Oneds::Mrproper::One::Helper.handle_opennebula_error { vm.info }

            vm
          rescue Oneds::Mrproper::Errors::One::ResourceNotFoundError => ex
            logger.error "Virtual Machine not found: #{ex.message}"
          end

          def done?(vm)
            vm.state == VM_DONE_STATE
          end
        end
      end
    end
  end
end
